#!/usr/bin/python
# -*- coding:utf-8 -*-

#global __flag_PIL
#try:
#    import Image
#    __flag_PIL = True
#except:
#    __flag_PIL = False
#    pass

def __n2( num ):
    return ( "0%d" % num )[ -2: ]

def __get_home():
    import tempfile, re, os
    file_temp = tempfile.mktemp()
    env = os.system( "/usr/bin/env > %s" % file_temp )
    path_home = "~/"
    for line in open( file_temp ).readlines():
        m = re.match( "HOME\\s*=\\s*(.+)", line.strip() )
        if m:
            path_home = m.group( 1 )
            break
        pass
    os.unlink( file_temp )
    return path_home

def __make_dir( dirname ):
    import os.path
    if os.path.exists( dirname ) == False:
        os.system( "mkdir -p \"%s\"" % dirname )
        pass
    pass

def __remove_older_files( directory, threshold ):
    import os.path, os
    for ( path, dirs, fns ) in os.walk( directory ):
        for fn in fns:
            filepath = "%s/%s" % ( path, fn )
            num = fn.split( "." )[ 0 ]
            #print filepath, threshold, num
            if num < threshold:
                #print "removing " + filepath
                os.unlink( filepath )
                pass
            pass
        pass
    pass

class __WeatherChartRetriever:
    def __init__( self, url, directory ):
        import os, os.path
        self.url = url
        self.url_base = url[ 0: url.rfind( '/' ) ]
        self.directory = directory
        if os.path.exists( directory ) == False:
            os.system( "mkdir -p \"%s\"" % directory )
            pass
        pass

    def __get_image_filename( self ):
        import time
        tm = time.localtime()
        name = "%d" % tm[0] + ("0%d" % tm[ 1 ] )[-2:] + ("0%d" % tm[ 2 ])[-2:] + ("0%d" % tm[ 3 ])[-2:]
        return "%s/%s.jpg" % ( self.directory, name )
        pass

    def retrieve( self ):
        import tempfile, os, time, string, re
        filename_tmp = tempfile.mktemp()
        filename_image = self.__get_image_filename()
        # already loaded
        if os.path.exists( filename_image ):
            return 'file:///' + filename_image
        
        command = "/usr/bin/curl %s -o %s -s" % ( self.url, filename_tmp )
        #print command
        os.system( command )
        r_img = re.compile( "<img\\s", re.I )
        r_src = re.compile( "\\bsrc\\s*=\\s*\"(images/[^\"]+)", re.I )
        r_size = re.compile( "width\\s*=\\s*\"?(\\d+)", re.I )
        path_url = None
        for line in open( filename_tmp ).readlines():
            m_img = r_img.search( line )
            if m_img:
                m_src = r_src.search( line )
                if m_src:
                    m_size = r_size.search( line, m_img.start() )
                    if m_size:
                        width = string.atoi( m_size.group( 1 ) )
                        if width > 200:
                            path_url = m_src.group( 1 )
                            break
                        pass
                    pass
                pass
            pass
        os.unlink( filename_tmp )
        if path_url:
            command = "/usr/bin/curl \"%s\" -o \"%s\" -s" % ( ( self.url_base + '/' + path_url ),  filename_image )
            os.system( command )
            return "file://" + filename_image
        return None

    def list_images( self ):
        import os, os.path
        images = []
        #print self.directory
        for ( path, dirs, fns ) in os.walk( self.directory ):
            for fn in fns:
                images.append( "file://" + self.directory + "/" + fn )
                pass
            pass
        images.sort( lambda x, y: - ( x > y ) )
        return images
    pass

if __name__ == "__main__":
    import os, sys
    global __dir_home
    __dir_home  = __get_home()
    __dir_image = "%s/Library/JPWeatherChart/" % ( __dir_home )
    generator = "snowy.weather.winter.stomy.cloudy"
    __base = generator[ 10 ] + generator[ -11 ] + generator[ 9 ] + "p:" + "//" + generator[ 3 ] + generator[ 7: 13 ]\
           + generator[ -7 ] + generator[ 8 ] + generator[ -12 ] + generator[ 8 ] + generator[ 10 ] + generator[ -18 ] + generator[ 20 ] + generator[ -6 ] + generator[ 2 ] + generator[ 24 ]
    __remove_threshold = None

    # remove or retain cache
    if sys.argv.count( '-retain' ) > 0:
        remove_cache = False
    else:
        remove_cache = True
        import time
        tm = time.localtime( time.time() - 3600 * 24 * 7 )
        __remove_threshold = "%d%s%s%s" % ( tm[ 0 ], __n2( tm[ 1 ] ), __n2( tm[ 2 ] ), __n2( tm[ 3 ] ) )
        #for dirname in ( "chart", "gms", "rain", "wind", "temp" ):
        #    __remove_older_files( __dir_image + dirname, threshold )
        #    pass
        pass

    # list all images for animation
    if sys.argv.count( '-list' ) > 0:
        list_mode = True
    else:
        list_mode = False
        pass

    for arg in sys.argv[ 1: ]:
        path_target = None
        if arg[ 0 ] == '-': continue
        if arg == 'chart':
            path_target = "/wxct/index.html"
        elif arg == 'gms':
            path_target = "/gms/index.html"
        elif arg == 'rain':
            path_target = "/amedas/rain.html"
            pass
        elif arg == 'wind':
            path_target = "/amedas/wind.html"
            pass
        elif arg == 'temp':
            path_target = "/amedas/index.html"
            pass
        if path_target == None: continue
        obj = __WeatherChartRetriever( __base + path_target,
                                       __dir_image + arg )
        if remove_cache:
            __remove_older_files( __dir_image + arg, __remove_threshold )
            pass

        if list_mode:
            uris = obj.list_images()
            if len( uris ) > 0:
                output = ""
                base_uri = uris[ 0 ][ 0: uris[ 0 ].rfind( '/' ) + 1 ]
                output += base_uri + "\n"
                #print base_uri
                for uri in uris:
                    start = uri.rfind( '/' ) + 1
                    end   = uri.rfind( '.' )
                    num = uri[ start : end ]
                    if len( output ) + len( num ) > 4095:
                        break
                    output += num + "\n"
                    pass
                print output
                pass
            pass
        else:
            try:
                print obj.retrieve()
            except:
                sys.stderr.write( "Network Error" );
            pass
        pass
    pass
